#include <fstream>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>

int main(int argc, char *argv[]) {
	//...
	long nrow = atol(argv[1]), ncol = atol(argv[2]), irow = atol(argv[3]), icol = atol(argv[4]), ntop = atol(argv[5]);
	long seed = atol(argv[6]); srand(seed);
	//...
	std::vector<std::vector<std::pair<int, int>  > > HEAP; std::queue<std::pair<std::pair<int, int>, int> > LIST;
	std::vector<std::pair<int, int> > STOP;
	std::set<std::pair<int, int> > USED;
	//...
	LIST.push({{irow, icol}, 0});
	while (LIST.size()) {
		static const int move[][8] = {
			{-2, -1, +1, +2, +2, +1, -1, -2}, {+1, +2, +2, +1, -1, -2, -2, -1}
		};
		auto it = LIST.front(); int b = it.first.second, a = it.first.first, l = it.second;
		if (l == HEAP.size()) HEAP.resize(l + 1);
		HEAP[l].push_back({a, b});
		LIST.pop();
		for (int k = 0; k < 8; ++ k) {
			int c = a + move[0][k], d = b + move[1][k];
			if ((c < 0) || (c >= nrow) ||
			    (d < 0) || (d >= ncol) ||
			    USED.count({c, d})) continue;
			USED.insert({c, d});
			LIST.push(
			{{c, d}, l + 1}
			);
		}
	}
	USED.clear();
	//...
	for (int i = 0; i < nrow; ++ i) for (int j = 0; j < ncol; ++ j) USED.insert({i, j});
	int l0 = HEAP.size() / 2;
	auto del = [&STOP, &USED, &HEAP] (int l) {
		STOP.push_back(HEAP[l][0]);
		USED.erase(HEAP[l][0]); HEAP[l][0] = HEAP[l].back(); HEAP[l].pop_back();
	};
	while (HEAP[l0].size() > 1) del(l0);
	if (!(seed % 2)) del(l0);
	//...
	std::random_shuffle(begin(STOP), end(STOP));
	std::ofstream fid("input.txt"); fid << nrow << "\t" << ncol << "\n";
	fid << STOP.size() << "\n";
	for (int i = 0; i < STOP.size(); ++ i) {
		fid << STOP[i].first << "\t" << STOP[i].second << "\n";
	}
	fid << ntop << "\n";
	for (int i = 0; i < ntop; ++ i) {
		//NOTE: 5 -- magic const number!
		int l = (i % 2)? (HEAP.size() - rand() % 5 - 1): (0);
		int k = rand() % HEAP[l].size();
		fid << HEAP[l][k].first << "\t";
		fid << HEAP[l][k].second;
		fid << "\n";
	}
	//...
	return 0;
}
